<?php
/*
Plugin Name: Better Delete Revision
Plugin URI: http://www.1e2.it/tag/better-delete-revision
Description: Better Delete Revision is based on the old "Delete Revision" plugin but it is compatible with latest Wordpress 3.0.1 and has implemented better new features (it is also better then Revision Removal plugin).
It does not only delete old redundant revisions of post from Database,it also delete every other content related to the revision, like post meta, tags, relationship and so on. Your current published post will never be touched! Your database will be optimized and all waste will be trashed ! In this way, your database will be lighter and small. This is the better optimization of your database you can do to speed up and make faster your Wordpress. 
Revision Post is the new features of WordPress ver 2.6 and above. Every time you made a change to your post or page, it will automatic save add a revision, just like a draft. As many as you made change, the more revision you will have in your database. It will not only increase your database size, but also increase your load time as the server need more time to access the database. If you modify many times, it will be a very frightening number! If you have 100 published posts, your revisiong may be as many as 1,000 articles! 
Better Delete Revision manager is your choice to remove all the revisions quickly to help you to increase the speed of implementation of the SQL statement, and increase the speed of your server load.
Author: Galerio
Version: 1.0
Author URI: http://www.1e2.it

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS
OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

/*
Changelog

2010-09-25	v1.0
			First public ver1.0
*/

	if(!get_option('bdel_revision_no')) {update_option("bdel_revision_no",0);}
	if(!get_option('bdel_revision_getPosts')) {update_option("bdel_revision_getPosts",0);}
	

	$dr_locale = get_locale();
	$dr_mofile = dirname(__FILE__) . "/better-delete-revision-$dr_locale.mo";
	load_textdomain('better-delete-revision', $dr_mofile);
	
function bdelete_revision_main() {
    if (function_exists('add_options_page')) {
	add_options_page('Better Delete Revision', 'Better Delete Revision',8, basename(__FILE__), 'my_options_bdelete_revision');
    }
 }

add_action('admin_menu', 'bdelete_revision_main');

function my_options_bdelete_revision() {
	$dr_ver = '1.0';
	$get_my_posts = get_my_posts();
	$bdel_revision_no = get_option('bdel_revision_no');
	echo <<<EOT
	<div class="wrap">
		<h2>Better Delete Revision Manager  <font size=1>ver $dr_ver</font></h2>
		<div class="widget"><p style="margin:10px;">
EOT;
		printf(__("Now You have <span style='color:red;font-weight:bolder;'> %s </span> posts. Up to now Better Delete Revision has removed <span id='revs_no' style='color:red;font-weight:bolder;'> %s </span> redundant post revision",'bdelete-revision'), $get_my_posts,$bdel_revision_no);
		echo '</p></div>';

	if (isset($_POST['del_act'])) {
		bdelete_revision_act();
		$del_no = $_POST['rev_no'];
		update_option("bdel_revision_no",get_option("bdel_revision_no") + $del_no);
		echo '<div class="updated" style="margin-top:50px;"><p><strong>';
		printf(__("Deleted <span style='color:red;font-weight:bolder;'> %s </span> revision posts !",'bdelete-revision'),$del_no);	
		echo "</strong></p></div></div><script>
		var del_no = document.getElementById('revs_no').innerHTML;
		document.getElementById('revs_no').innerHTML = Number(del_no)+ $del_no;
		</script>";
	}
	elseif (isset($_POST['get_rev'])) {
		get_my_revision();
		
	}
	elseif (isset($_POST['maintain_mysql'])) {
		if ($_POST['operation'] == 'OPTIMIZE' ) {echo maintain_mysql('OPTIMIZE');}
		else echo maintain_mysql('CHECK');
	}
	else {
		echo '<form method="post" action="">';
		echo '<input class="button" type="submit" name="get_rev" value="';
		_e('Check Revision Posts','bdelete-revision');
		echo '" />  <input class="button" type="submit" name="maintain_mysql" value="';
		_e('Optimize Your Database','bdelete-revision');
		echo '" /></form></div>';

	}
	
	echo '<br /><div class="widget"><div style="margin:12px;line-height: 1.5em;">';
	_e('Revision Post is the new features of WordPress ver 2.6 and above. Every time you made a change to your post or page, it will automatic save add a revision, just like a draft. As many as you made change, the more revision you will have in your database. It will not only increase your database size, but also increase your load time as the server need more time to access the database. If you modify many times, it will be a very frightening number!','bdelete-revision');
	_e('If you have 100 published posts, your revisiong may be as many as 1,000 articles!','bdelete-revision');
	echo '<br />';
	_e('Better Delete Revision manager is your choice to remove all the revisions quickly to help you to increase the speed of implementation of the SQL statement, and increase the speed of your server load.','bdelete-revision');
	echo '<br />';
	_e('Thank you for your useing. I hope you like it!','bdelete-revision');
	_e('Author','bdelete-revision');
	echo ': <a href="http://www.1e2.it" target="_blank">http://www.1e2.it</a></div></div>';
	
}

function get_my_posts() {
	global $wpdb;
	
	$sql = "SELECT ID
			FROM (
			$wpdb->posts
			)
			WHERE `post_type` = 'post'";
	$results = $wpdb -> get_results($sql);
	return count($results);
}

function get_my_revision() {
	global $wpdb;
	
	$sql = "SELECT `ID`,`post_date`,`post_title`,`post_modified`
			FROM (
			$wpdb->posts
			)
			WHERE `post_type` = 'revision'
			ORDER BY `ID` DESC";
	$results = $wpdb -> get_results($sql);
	if($results) {
	$res_no = count($results);
	echo "<table class='widefat'><thead>";
	echo "<tr><th width=30> Id </th><th width=450> Title </th><th width=180> Post date </th><th width=180> Last modified </th></tr></thead>";
	for($i = 0 ; $i < $res_no ; $i++) {
		echo "<tr><td>".$results[$i] -> ID."</td>";
		echo "<td>".$results[$i] -> post_title."</td>";
		echo "<td>".$results[$i] -> post_date."</td>";
		echo "<td>".$results[$i] -> post_modified."</td></tr>";
	}
	echo "</table><br />";
	echo "Would you like to remove the revision posts ? <br />";
	echo <<<EOT
		<form method="post" action="">
		<input type="hidden" name="rev_no" value=" $res_no " />
EOT;
		echo '<input class="button-primary" type="submit" name="del_act" value="';
		printf(__('Yes , I would like to delete them!(A Total Of %s)','bdelete-revision'),$res_no);
		echo '" /><input class="button" type="submit" name="goback" value="';
		_e('No , I prefer to keep it!','bdelete-revision');
		echo '" /></form></div>';

	}
	else {echo "<div class=\"updated\" style=\"margin:50px 0;padding:6px;line-height:16pt;font-weight:bolder;\">";
	_e('Great, You have no revision posts now!','bdelete-revision');
	echo "</div></div>";}
}

function bdelete_revision_act() {
	global $wpdb;
	
	$sql = "DELETE a,b,c FROM $wpdb->posts a LEFT JOIN $wpdb->term_relationships b ON (a.ID = b.object_id) LEFT JOIN $wpdb->postmeta c ON (a.ID = c.post_id) WHERE a.post_type = 'revision'";
	$results = $wpdb -> get_results($sql);


}

function maintain_mysql($operation = "CHECK"){
		global $wpdb;
       
        $Tables = $wpdb -> get_results('SHOW TABLES IN '.DB_NAME);
        $query = "$operation TABLE ";

		$Tables_in_DB_NAME = 'Tables_in_'.DB_NAME;
        foreach($Tables as $k=>$v){
			$_tabName = $v -> $Tables_in_DB_NAME ;
           $query .= " `$_tabName`,";
        }

        $query = substr($query,0,strlen($query)-1);
        $result = $wpdb -> get_results($query);
		if ($operation == "OPTIMIZE") {
			return '<h3>'.__('Optimization of database completed.','bdelete-revision').'</h3>';
		}

        $res = "<table border=\"0\" class=\"widefat\">";
        $res .= "<thead><tr>
			<th>Table</th>
			<th>OP</th>
			<th>Status</th>
			</tr><thead>";
        $bgcolor = $color3;
		foreach($result as $j=>$o) {
            $res .= "<tr>";
            foreach ($o as $k=>$v) {
				$tdClass = $j%2 == 1 ? 'active alt' : 'inactive';
				if($k == 'Msg_type') continue;
				if($k == 'Msg_text' ) {
					if ($v == 'OK') {
					$res .= "<td class='$tdClass' ><font color='green'><b>$v</b></font></td>";
					}
					else {
					$res .= "<td class='$tdClass' ><font color='red'><b>$v</b></font></td>";
					}
				}
				else $res .= "<td class='$tdClass' >$v</td>";
            }
            $res .= "</tr>";
        }
        $res .= "<tfoot><tr><th colspan=3>".__('If the Status is green <font color=green>OK</font>, then indicated that is normal, does not need any operation, please go back; If is red, then click on the following button to optimize.','bdelete-revision')."</th></tr></tfoot></table>";
		$res .= "<br /><form method='post' action=''>
			<input name='operation' type='hidden' value='OPTIMIZE' />
			<input name='maintain_mysql' type='hidden' value='OPTIMIZE' />
			<input name='submit' type='submit' class='button-primary' value='".__('Optimize your Database','bdelete-revision')."' /></form>";
        return $res;
    }

?>